/*
 * Copyright (c) 2005 Kuan-li Pong
 *
 * This file is part of the "chess" game library. "chess" is free
 * software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this library; see the file COPYING.  If not, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 */

#include "chess.hpp"

namespace Chess{

	Chess::Chess(const Chess& chess)
		:color(chess.color), id(chess.id), covered(chess.covered){
	}

	Chess::Chess(Chess& chess)
		:color(chess.color), id(chess.id), covered(chess.covered){
	}

	Chess::Chess(int c_id, Color col, bool cov)
		:color(col), id(c_id), covered(cov){
		checkChessID();
	}

	void Chess::cover(){
		covered = true;
	}
	
	/*bool Chess::eat(Chess& chess){
		int dx = abs(pos_x - chess.pos_x);
		int dy = abs(pos_y - chess.pos_y);
		if(covered && strongerThan(chess) && (dx == 0 && dy == 1 || dx == 1 && dy == 0)){
			board.removeChess(chess);
			//pos_x = chess.pos_x;
			//pos_y = chess.pos_y;
			board.moveChess(pos_x, pos_y, chess.pos_x, chess.pos_y);
			return true;
		}
		return false;
	}*/
	
	/*bool Chess::moveTo(int x, int y){
		if(covered && x >= 0 && x < ChessBoard::N_COLS && y >= 0 && y < ChessBoard::N_ROWS){
			int dx = abs(pos_x - x);
			int dy = abs(pos_y - y);
			if(dx == 0 && dy == 1 || dx == 1 && dy == 0){
				pos_x = x;
				pos_y = y;
				return true;
			}
		}
		return false;
	}*/

	/*void Chess::place(int x, int y){
		if(x >= 0 && x < ChessBoard::N_COLS && y >= 0 && y < ChessBoard::N_ROWS){
			pos_x = x;
			pos_y = y;
		}
	}*/

}

