/*
 * Copyright (c) 2005 Kuan-li Pong
 *
 * This file is part of the "chess" game library. "chess" is free
 * software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this library; see the file COPYING.  If not, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 */

#ifndef CHESS_HPP
#define CHESS_HPP

namespace Chess{

	/**
	 * Class Chess
	 * ѤlO
	 */
	class Chess{
		public:
			const static int
				CHESS_CHANG = 0,	//N
				CHESS_SHI = 1,		//hK
				CHESS_SHANG = 2,	//H
				CHESS_CHU = 3,		//
				CHESS_MA = 4,		//
				CHESS_PAOU = 5,		//]
				CHESS_TSU = 6;		//L

			enum Color{
				BLUE,
				RED
			};

		public:
			Chess(const Chess& chess);
			Chess(Chess& chess);
			Chess(int c_id, Color col, bool cov = false);

		public:
			inline int getID() { return id; }
			inline Color getColor() { return color; }
			inline bool isCovered() { return covered; }
			void cover();

		private:
			void checkChessID(){
				if(id < 0 || id > 6)
					throw InvalidChessException();
			}

		private:
			/*const */int id;
			/*const */Color color;
			bool covered;

		public:
			class InvalidChessException {};
	};
}

#endif
