/*
 * Copyright (c) 2005 Kuan-li Pong
 *
 * This file is part of the "chess" game library. "chess" is free
 * software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this library; see the file COPYING.  If not, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 */

#ifndef CHESSBOARD_HPP
#define CHESSBOARD_HPP

namespace Chess{

	class Chess;

	/**
	 * Class ChessBoard
	 * ѽLO
	 */
	template<int N_COLS, int N_ROWS>
	class ChessBoard{
		public:
			ChessBoard();
			void setSelectedChess(Chess* chess);
			inline Chess* getSelectedChess() { return selected; }
			Chess* getChess(int x, int y);
			void setChess(int x, int y, Chess* chess);
			void moveChess(int x1, int y1, int x2, int y2);
			void removeChess(int x, int y);
			void getChessPosition(const Chess* chess, int &x, int &y);
		private:
			inline bool examinePosition(int x, int y){
				return (x >= 0 && x < N_COLS && y >= 0 && y < N_ROWS);
			}
		private:
			//Color turn;				//ثea
			Chess* board[N_COLS][N_ROWS];		//N_COLS x N_ROWS ѽL
			Chess* selected;		//wwѤl
			//Renderer& renderer;		//ѭϧοX
			//Input& input;			//NϧΤJରѭJ
	};
}

#include "chessboard.cpp"

#endif
