/*
 * Copyright (c) 2005 Kuan-li Pong
 *
 * This file is part of the "chess" game library. "chess" is free
 * software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this library; see the file COPYING.  If not, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 */

#ifndef OUTPUTLISTENER_HPP
#define OUTPUTLISTENER_HPP

#include <vector>
#include <glibmm/ustring.h>
#include "chess.hpp"
#include "enums.hpp"

namespace Chess{

	/**
	 * Class OutputListener
	 * CX,sRuleX̬һ~ӦۦO
	 */
	class OutputListener{
		public:
			enum EndStatus{
				PLAYER_BLUE_WIN,
				PLAYER_RED_WIN,
				PLAYER_1_WIN,
				PLAYER_2_WIN,
				DRAW,
				DROP
			};

		public:
			OutputListener() { }
			/* C}l */
			virtual void start(int n_cols, int n_rows, std::vector<Chess> chesses) = 0;
			/* C */
			virtual void end(EndStatus status) = 0;
			/* ]waN */
			virtual void setPlayerName(Turn turn, Glib::ustring name) = 0;
			/* ]wثe쪺a */
			virtual void setCurrentPlayer(Turn turn) = 0;
			/* sثeaѩѼ */
			virtual void updatePlayer(Turn turn, int remains) = 0;
			/*  */
			virtual void moveChess(int x1, int y1, int x2, int y2) = 0;
			/* ½ */
			virtual void uncoverChess(int x, int y) = 0;
			/* Y */
			virtual void removeChess(int x, int y) = 0;
			/* ]w襤Ѥl */
			virtual void setSelectedChess(int x, int y, bool select) = 0;
			/* ]wT */
			virtual void setMessage(Glib::ustring message) = 0;
			virtual ~OutputListener() { }
	};
}

#endif
