/*
 * Copyright (c) 2005 Kuan-li Pong
 *
 * This file is part of the "chess" game library. "chess" is free
 * software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this library; see the file COPYING.  If not, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 */

#ifndef PLAYER_HPP
#define PLAYER_HPP

#include <glibmm/ustring.h>
#include "chess.hpp"

namespace Chess{

	using Glib::ustring;

	/**
	 * Class Player
	 * aO
	 */
	class Player{
		/*using Chess::CHESS_CHANG;
		using Chess::CHESS_SHI;
		using Chess::CHESS_SHANG;
		using Chess::CHESS_CHU;
		using Chess::CHESS_MA;
		using Chess::CHESS_PAOU;
		using Chess::CHESS_TSU;*/

		public:
			enum State{
				PLAYING,
				WIN,
				LOSE
			};


		public:
			Player(Glib::ustring& player_name);
			Player(Player& player);
			int getChess(int chess_id);
			int getChesses();
			void removeChess(int chess_id);
			void win();
			void lose();
			inline State getState() { return state; }
			inline ustring getName() { return name; }

		private:
			void initChesses();

		private:
			ustring name;
			int chesses[7];
			State state;
	};
}

#endif
